/*
 *   Copyright (C) 2016 by Jonathan Naylor G4KLX
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#if !defined(Trellis_H)
#define	Trellis_H

#include <cstdint>

class CTrellis
{
public:
	CTrellis();
	~CTrellis();

	void decode(const unsigned char* in, unsigned char* out);

private:
	void extractDiBits(const unsigned char* in, int8_t* dibits) const;
	void constellationOut(const int8_t* dibits, uint8_t* cons) const;
	bool tribitExtract(const uint8_t* cons, uint16_t* tris) const;
	void binaryConvert(const uint16_t* tris, unsigned char* out) const;
};

#endif
